#import "VNC.h"
#import "vncviewer.h"

int useFunctions = 1;			// undo this, its a hack!
extern int nFramebufferDepth;		// and this too!

@implementation VNCController

static VNCController *sharedInstance = nil;

+ (VNCController *)controller
{
    return sharedInstance;
}

+ (NXCursor *)hollowCursor
{
    return [sharedInstance hollowCursor];
}

- (NXCursor *)hollowCursor
{
    return _hollowCursor;
}

+ initialize
{
	return self;
}

- (NSArray *)displayManagers
{
    return [[_displayManagers copy] autorelease];
}

- (id)init
{
    if (self = [super init]) {
		NXPoint hotSpot;
        [[NSNotificationCenter defaultCenter] addObserver:self
		selector:@selector(displayWillClose:)
		//name:VNCDisplayWillTerminateNotification
		/* balazs.pataki@sztaki.hu: in 3.3 it's slighlty different
		*/
		notificationName:VNCDisplayWillTerminateNotification
		object:nil];
        
        sharedInstance = self;

        _hollowCursor = [[NXCursor alloc] initFromImage:[NXImage findImageNamed:"VNCHollowCursor"]];
		
		hotSpot.x = 8.0;
		hotSpot.y = 8.0;
		[_hollowCursor setHotSpot:&hotSpot];
    }

    return self;
}

- appDidInit:sender
{
    _displayManagers = [[NSMutableArray alloc] init];

    [updateMenuItem setEnabled:NO];
    return self;
}

- (void)displayWillClose:(NSNotification *)notification
{
   /* balazs.pataki@sztaki.hu: slighlty fidderent in NS3.3 */
    VNCDisplayManager *manager = [notification notificationObject];

    [_displayManagers removeObject:manager];
    if ([_displayManagers count] == 0)
        [updateMenuItem setEnabled:NO];
}

- appWillTerminate:sender
{
    VNCDisplayManager *manager;
    NSEnumerator *displayEnumerator = [_displayManagers objectEnumerator];

    while (manager = [displayEnumerator nextObject])
        if (![manager performClose])
            return nil;

    return self;
}

- (void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [_displayManagers release];

    [super dealloc];
}

- openPanelOkClicked:sender
{
	const char *hostStr;
	const char *passwdStr;
    	NSString *host;
    	int port = 0;
	int depth = 0;
    	VNCDisplayManager *manager;
	
    	passwdStr = [authenticationPanelTextField stringValue];
    	hostStr = [displayEntryTextField stringValue];
    	port = [displayEntryPortField intValue];
	host = [NSString stringWithCString:hostStr];
	depth = [[anthenticationPanelDepthMatrix selectedCell] tag];

    	[displayOpenPanel close];

    	NS_DURING {
        _rfbProto = [RFBProtocolAdaptor adaptorWithHost:host port:port];

        [_rfbProto readServerVersionMessage];
        [_rfbProto sendClientVersionMessage];

        if ([_rfbProto readServerAuthScheme] == RFBVNCAuthorization) {
            NSData *challenge = [_rfbProto readServerAuthChallenge];

            NSString *key = [NSString stringWithFormat:@"Password-%@-%d", host, port];
			NSString *password = [NSString stringWithCString:passwdStr];

	     if (![_rfbProto authorizeWithPassword:password challenge:challenge]) {
        		NXRunAlertPanel("Invalid Password",
                        "The password you typed was not valid, please try again!",
                        "Ok", NULL, NULL);
			goto EXIT_IMMEDIATE;
       	     }
       }

        // do initial handshaking
        [_rfbProto sendClientInitializationWithSharedDesktop:YES];
        [_rfbProto readServerInitializationMessage];

	/* balazs.pataki@sztaki.hu: setup the function interface variables
	** as well
	*/
	rfbsock = [[_rfbProto socket] fileDescriptor];
	
	desktopName = [[_rfbProto desktopName] cString];
	
	si.framebufferWidth = [_rfbProto width];
	si.framebufferHeight = [_rfbProto height];
	si.format.redMax = [_rfbProto redMax];
	si.format.greenMax = [_rfbProto greenMax];
	si.format.blueMax = [_rfbProto blueMax];
	si.nameLength = [[_rfbProto desktopName] length];
	
	updateRequestX = 0;
	updateRequestY = 0;
	updateRequestW = [_rfbProto width];
	updateRequestH = [_rfbProto height];

        // set up transmission
        [_rfbProto sendEncodings:[RFBRectangle supportedEncodings]
                           count:[RFBRectangle numberOfSupportedEncodings]];

	switch (depth) {
	 case 0:
		[_rfbProto sendBitsPerPixel:32 depth:24
                                  bigEndian:YES trueColour:YES
                                     redMax:255 greenMax:255 blueMax:255
                                   redShift:24 greenShift:16 blueShift:8];
		nFramebufferDepth=32;
		break;
	 case 1:
#ifdef i386
	       // duno why bigEndian must be NO but it works this way
               [_rfbProto sendBitsPerPixel:16 depth:12
                                  bigEndian:NO trueColour:YES
                                     redMax:15 greenMax:15 blueMax:15
                                   redShift:12 greenShift:8 blueShift:4];
#else
               [_rfbProto sendBitsPerPixel:16 depth:12
                                  bigEndian:YES trueColour:YES
                                     redMax:15 greenMax:15 blueMax:15
                                   redShift:12 greenShift:8 blueShift:4];
#endif
		nFramebufferDepth=16;
		break;
	 case 2:
                [_rfbProto sendBitsPerPixel:8 depth:6
                                  bigEndian:YES trueColour:YES
                                     redMax:3 greenMax:3 blueMax:3
                                   redShift:6 greenShift:4 blueShift:2];
		nFramebufferDepth=8;
		break;
	 default:
		return;
	}
	/* balazs.pataki@sztaki.hu: setup the function interface variables
	** as well
	*/
	//canUseCoRRE = 
	//canUseHextile = 

	myFormat.bitsPerPixel = [_rfbProto bitsPerPixel];
	myFormat.depth = [_rfbProto depth];
	myFormat.bigEndian = [_rfbProto bigEndian];
	myFormat.trueColour = [_rfbProto trueColour];
	myFormat.redMax = [_rfbProto redMax];
	myFormat.greenMax = [_rfbProto greenMax];
	myFormat.blueMax = [_rfbProto blueMax];
	myFormat.redShift = [_rfbProto redShift];
	myFormat.greenShift = [_rfbProto greenShift];
	myFormat.blueShift = [_rfbProto blueShift];

        // once authorization is done, hand over to the display manager
        manager = [[[VNCDisplayManager alloc] initWithAdaptor:_rfbProto] autorelease];
        [_displayManagers addObject:manager];
        
	EXIT_IMMEDIATE:
	manager=manager;	// empty statement needed
    }
    NS_HANDLER {
        NXRunAlertPanel("Connection error",
                        "Exception connecting to %s:%d: %s",
                        "Rats!", NULL, NULL,
                        hostStr, port, "");
    }
    NS_ENDHANDLER;
}

- authenticationPanelOkClicked:sender
{
	return self;
}

- updateForemostDisplay:sender
{

    VNCDisplayManager *manager = [[NXApp mainWindow] delegate];

    if (manager != nil) {
        if (NXRunAlertPanel("Confirm Update",
                            "Updating may take a long time. Really update?",
                            "Yes", "No", NULL) == NX_ALERTDEFAULT)
            [manager requestFullUpdate:nil];
    }

}

- orderFrontStatisticsPanel:sender
{
	return self;
}

- takeSnapshotOfFrontWindow:sender
{
	return self;
#if 0
    VNCDisplayManager *manager = [[NSApp mainWindow] delegate];

    if (manager != nil) {
        NSSavePanel *savePanel = [NSSavePanel savePanel];

        [savePanel setTitle:@"Save Desktop"];
        [savePanel setRequiredFileType:@"tiff"];

        if ([savePanel runModalForDirectory:@""
                                       file:[[manager adaptor] desktopName]] == NSOKButton)
            [[manager desktopTIFFRepresentation] writeToFile:[savePanel filename]
                                                  atomically:NO];
    }
#endif /* 0 */
}

@end
