#import "VNC.h"
#import "vncviewer.h"

@implementation VNCDisplayView

- (id)initWithFrame:(NXRect)initFrame
{
    if (self = [super initFrame:&initFrame]) {
        _framebuffer = [(VNCFramebuffer*)[VNCFramebuffer alloc] initWithSize:initFrame.size];
    }

    return self;
}

- (void)dealloc
{
    [_framebuffer release];

    [super dealloc];
}

- (VNCFramebuffer *)framebuffer
{
    return _framebuffer;
}

- (void)drawRect:(NXRect*)frameRect
{
    [_framebuffer update];
}

int initial = 1;

- drawSelf:(const NXRect *)rects :(int)rectCount
{
/*
	NXRect rect;
	[self getFrame:&rect];
	
	NXSetColor(NX_COLORBLACK);
	NXRectFill (&rect);
*/
	if (_completeRedrawNeeded) {
     	[_framebuffer update];
		_completeRedrawNeeded = NO;
	}
    else
		[_framebuffer updateMinimum];
	
/*
	if (initial)
     	[_framebuffer update];
   else if (!noRect)
   		[_framebuffer updateRect:drawRect];
	noRect = 1;
*/
	return self; //[super drawSelf:rects :rectCount];
}

- (BOOL)acceptsFirstResponder
{
    return NO;
}

- (void) setNeedCompleteRedraw:(BOOL)flag
{
	_completeRedrawNeeded = YES;
}

- superviewSizeChanged:(const NXSize *)oldSize
{
	_completeRedrawNeeded = YES;
	return [super superviewSizeChanged:oldSize];
}

- sizeTo:(NXCoord)width :(NXCoord)height
{
	_completeRedrawNeeded = YES;
	return [super sizeTo:width :height];
}

- setFrame:(const NXRect *)frameRect
{
	_completeRedrawNeeded = YES;
	return [super setFrame:frameRect];
}

- moveTo:(NXCoord)x :(NXCoord)y
{
	_completeRedrawNeeded = YES;
	return [super moveTo:x :y];
}

- windowWillResize:sender toSize:(NXSize *)frameSize
{
	_completeRedrawNeeded = YES;
	return self;
}

- windowDidResize:sender
{
	_completeRedrawNeeded = YES;
	return self;
}

- windowDidUpdate:sender
{
	_completeRedrawNeeded = YES;
	return self;
}

@end
