/*
 * VNCFramebuffer.h
 * A simple off-screen framebuffer optimized for drawing rectangles and raw images.
 *
 * Copyright (c) 1997 21st Century Software, New York City.
 *
 * See the file Reference/License.rtf for information on usage and
 * redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by David Young <dwy@ace.net>, 1997.
 */
#import <dpsclient/event.h>

@interface VNCFramebuffer : NSObject
{
    unsigned _width, _height;
    unsigned _bytesPerRow;
    NXRect _minimumUpdateRect;
    NSMutableData *_framebufferCover;
    unsigned *_framebufferPtr;
}

- (id)initWithSize:(NXSize)size;

- (NXImage *)framebufferImage;

- (void)compositePixelData:(NSData *)pixelData targetRect:(NXRect)target bitsPerPixel:(unsigned)bitsPerPixel;
- (void)compositeRawPixelData:(unsigned int *)pixelData targetRect:(NXRect)target bitsPerPixel:(unsigned)bitsPerPixel;

- (NSData *)subPixelsInRect:(NXRect)rect;

- (void)copyPixelsFromRect:(NXRect)sourceRect toRect:(NXRect)destinationRect;

- (void)fillRect:(NXRect)rect color:(unsigned)color;
- (void)fillRectList:(const NXRect *)rectList colorList:(const unsigned *)colorList count:(unsigned)count;

- (void)update;
- (void)updateMinimum;

- (void) display;
@end

