
#import <appkit/appkit.h>
#include "vncviewer.h"
#import  "VNCView.h"

DPSTimedEntry tick;
fd_set fds;
int msWait;
struct timeval tv, *tvp;
NSAutoreleasePool *pool;


void tickHandler(DPSTimedEntry tag, double now, void *userData)
{
	if (sendUpdateRequest) {
		if (!SendIncrementalFramebufferUpdateRequest()) {
		    ShutdownX();
		    exit(1);
		}
	}

#if 0
//	DPSRemoveTimedEntry (tag);

	if (sendUpdateRequest) {
	    gettimeofday(&tv, NULL);

	    msWait = (updateRequestPeriodms +
		      ((updateRequestTime.tv_sec - tv.tv_sec) * 1000) +
		      ((updateRequestTime.tv_usec - tv.tv_usec) / 1000));

	    if (msWait > 0) {
		tv.tv_sec = msWait / 1000;
		tv.tv_usec = (msWait % 1000) * 1000;

		tvp = &tv;
	    } else {
		if (!SendIncrementalFramebufferUpdateRequest()) {
		    ShutdownX();
		    exit(1);
		}
	    }
	}

/*	
	if (sendUpdateRequest) {
		if (!SendIncrementalFramebufferUpdateRequest()) {
		    ShutdownX();
		    exit(1);
		}
	}
*/
 //   tick =  DPSAddTimedEntry(0.1, tickHandler, NULL, NX_BASETHRESHOLD);
#endif /* 0 */
	
}

void
rfbHandler (int fd, void *userData)
{

	DPSRemoveTimedEntry (tick);
	if (!HandleRFBServerMessage()) {
		ShutdownX();
		exit(1);
	}
	tick =  DPSAddTimedEntry(0.0, tickHandler, NULL, NX_BASETHRESHOLD);

#if 0
	if (sendUpdateRequest) {
	    gettimeofday(&tv, NULL);

	    msWait = (updateRequestPeriodms +
		      ((updateRequestTime.tv_sec - tv.tv_sec) * 1000) +
		      ((updateRequestTime.tv_usec - tv.tv_usec) / 1000));

	    if (msWait > 0) {
		tv.tv_sec = msWait / 1000;
		tv.tv_usec = (msWait % 1000) * 1000;

		tvp = &tv;
	    } else {
		if (!SendIncrementalFramebufferUpdateRequest()) {
		    ShutdownX();
		    exit(1);
		}
	    }
	}

	FD_ZERO(&fds);
	FD_SET(rfbsock,&fds);

	if (select(FD_SETSIZE, &fds, NULL, NULL, tvp) < 0) {
	    perror("select");
	    ShutdownX();
	    exit(1);
	}

	if (FD_ISSET(rfbsock, &fds)) {
		DPSRemoveTimedEntry (tick);
	    if (!HandleRFBServerMessage()) {
		ShutdownX();
		exit(1);
	    }
    	tick =  DPSAddTimedEntry(0.0, tickHandler, NULL, NX_BASETHRESHOLD);
	}

/*	
	gettimeofday(&tv, NULL);

	if (select(FD_SETSIZE, &fds, NULL, NULL, NULL) < 0) {
	    perror("select");
	    ShutdownX();
	    exit(1);
	}

	if (FD_ISSET(rfbsock, &fds)) {
	    if (!HandleRFBServerMessage()) {
		ShutdownX();
		exit(1);
	    }
	}
*/
#endif /* 0 */
}

extern Bool
CreateAppkitWindow()
{
	NXRect rect;
	Window *win;
	VNCInputView *inputView;

	pool = [[NSAutoreleasePool alloc] init];
	
    [Application new];

	NXSetRect (&rect, 100, 100, 700, 700);
	
	win = [[Window alloc]
					initContent:&rect
					style:NX_RESIZEBARSTYLE
					backing:NX_BUFFERED /*NX_RETAINED, NX_NONRETAINED */
					buttonMask:NX_MINIATURIZEBUTTONMASK|NX_CLOSEBUTTONMASK
					defer:YES];
	//[win addToEventMask:NX_MOUSEENTEREDMASK|NX_MOUSEEXITEDMASK];
	[win setEventMask:
				NX_MOUSEMOVEDMASK	|
				NX_LMOUSEDOWNMASK	|
				NX_LMOUSEUPMASK		|
				NX_RMOUSEDOWNMASK	|
				NX_RMOUSEUPMASK		|
				NX_LMOUSEDRAGGEDMASK|
				NX_RMOUSEDRAGGEDMASK|
				NX_MOUSEENTEREDMASK |
				NX_MOUSEEXITEDMASK	|
				NX_KEYDOWNMASK		|
				NX_KEYUPMASK];
	NXSetRect (&rect, 0, 0, 1024, 768);
	dpy = [[VNCDisplayView alloc] initWithFrame:rect];
	[dpy setAutosizing:
			NX_MINXMARGINSIZABLE	|
			NX_WIDTHSIZABLE			|
			NX_MAXXMARGINSIZABLE	|
			NX_MINYMARGINSIZABLE	|
			NX_HEIGHTSIZABLE		|
			NX_MAXYMARGINSIZABLE];
	[[win contentView] addSubview:dpy];
	
	inputView = [[VNCInputView alloc] initWithFrame:rect adaptor:nil];
	[inputView setFlipped:YES];
	[[win contentView] addSubview:inputView];

	[inputView getFrame:&rect];
	[win setTrackingRect:&rect
				inside:NO
				owner:inputView
				tag:5800
				left:NO
				right:NO];

	[win setDelegate:inputView];

	/*	rfb config
	*/
	myFormat.bitsPerPixel = 32;
	myFormat.depth = 24;
	myFormat.trueColour = 1;
	myFormat.bigEndian = 0;
	myFormat.redMax = myFormat.greenMax = myFormat.blueMax = 255;
	myFormat.redShift = 0;
	myFormat.greenShift = 8;
	myFormat.blueShift = 16;

	addCopyRect = addHextile = addCoRRE = addRRE = False;
	

    if (!SetFormatAndEncodings()) {
	ShutdownX();
	exit(1);
    }

    if (!SendFramebufferUpdateRequest(updateRequestX, updateRequestY,
				      updateRequestW, updateRequestH, False)) {
	ShutdownX();
	exit(1);
    }

	
	[win makeKeyAndOrderFront:nil];
	[win makeFirstResponder:inputView];

	FD_ZERO(&fds);
	FD_SET(rfbsock,&fds);
	DPSAddFD(rfbsock, rfbHandler, NULL, 15);

    tick =  DPSAddTimedEntry(0.0, tickHandler, NULL, 30);
    //DPSAddTimedEntry(0.1, initialReadHandler, NULL, NX_BASETHRESHOLD);

	[NXApp run];
    [NXApp free];
	[pool release];
	return True;
}


extern void
ShutdownApp ()
{
    [NXApp free];
}


